/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                                                                                 *
 * ALPS Project: Algorithms and Libraries for Physics Simulations                  *
 *                                                                                 *
 * ALPS Libraries                                                                  *
 *                                                                                 *
 * Copyright (C) 2011 - 2012 by Mario Koenz <mkoenz@ethz.ch>                       *
 *                                                                                 *
 * This software is part of the ALPS libraries, published under the ALPS           *
 * Library License; you can use, redistribute it and/or modify it under            *
 * the terms of the license, either version 1 or (at your option) any later        *
 * version.                                                                        *
 *                                                                                 *
 * You should have received a copy of the ALPS Library License along with          *
 * the ALPS Libraries; see the file LICENSE.txt. If not, the license is also       *
 * available from http://alps.comp-phys.org/.                                      *
 *                                                                                 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR     *
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,        *
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT       *
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE       *
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,     *
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER     *
 * DEALINGS IN THE SOFTWARE.                                                       *
 *                                                                                 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef ALPS_NGS_ALEA_FEATURES_FEATURES_HPP
#define ALPS_NGS_ALEA_FEATURES_FEATURES_HPP

namespace alps {
    namespace accumulator  {

        template<
              typename A0  = void
            , typename A1  = void
            , typename A2  = void
            , typename A3  = void
            , typename A4  = void
            , typename A5  = void
            , typename A6  = void
            , typename A7  = void
            , typename A8  = void
            , typename A9  = void
            , typename A10  = void
            , typename A11  = void
            , typename A12  = void
            , typename A13  = void
            , typename A14  = void
            , typename A15  = void
            , typename A16  = void
            , typename A17  = void
            , typename A18  = void
            , typename A19  = void
        >
        struct features {
            typedef A0 T0;
            typedef A1 T1;
            typedef A2 T2;
            typedef A3 T3;
            typedef A4 T4;
            typedef A5 T5;
            typedef A6 T6;
            typedef A7 T7;
            typedef A8 T8;
            typedef A9 T9;
            typedef A10 T10;
            typedef A11 T11;
            typedef A12 T12;
            typedef A13 T13;
            typedef A14 T14;
            typedef A15 T15;
            typedef A16 T16;
            typedef A17 T17;
            typedef A18 T18;
            typedef A19 T19;
        };

    }
}

#endif // ALPS_NGS_ALEA_FEATURES_FEATURES_HPP
