set size ratio 0.8 2.5,2.2
set terminal postscript color eps enhanced fontfile 'helpers/sfsl1000.pfb' fontfile 'helpers/sfrm1000.pfb' fontfile 'helpers/sfss1000.pfb' 64
set encoding iso_8859_1
set output "sigma.eps"
set origin 0,0
unset label
set auto
set tics scale 4
set xtics 0.5 font "SFRM1000"
set mxtics 2
set ytics 0.2 font "SFRM1000"
set mytics 2
set xrange [0:2.5]
set yrange [-1.2:0] 
set ylabel "{/SFSL1000 Im[{/Symbol S}(i{/Symbol w}_n)]}" 0,0 font "Helvetica, 72"
set xlabel "{/SFSL1000 {/Symbol w}_n}" 1.0,0 font "Helvetica, 72"
set key 2.4,-0.05
plot "sigma_hirschfye" using 1:3 w linespoints lt 2 lw 2 ps 3 pt 7 lc rgb "red" title "{/SFSL1000 Hirsch-Fye}", \
"sigma_hyb" using 1:3 w linespoints lt 2 lw 2 ps 3 pt 7 lc rgb "blue" title "{/SFSL1000 CT-HYB}", \
"sigma_int" using 1:3 w linespoints lt -1 lw 2 ps 3 pt 9 lc rgb "green" title "{/SFSL1000 CT-INT}"
!perl -pi -e 's/%%BoundingBox: 50 50 842 604/%%BoundingBox: 120 50 780 590/' sigma.eps

